<?php
/**
 * Setting Page
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

if(is_admin()){
	include_once dirname(__FILE__).'/hooks.php';
}

final class PhilNaAdmin {
	private $defaultOpt = array(
		'string'=>array(
			'keywords',
			'description',
			'notice_content',
			'showcase_title',
			'showcase_content',
			'feed_url',
			'feed_url_email',
			'twitter',
			'rss_additional',
		),
		'bool'=>array(
			'notice',
			'showcase_registered',
			'showcase_commentator',
			'showcase_visitor',
			'showcase_caption',
			'feed',
			'feed_email',
			'show_twitter',
			'rss_additional_show',
		),
	);

	private $allOpt = array();

	private $philnaOpt = array();

	public function __construct(){
		// Add a admin page
		if(is_admin()){
			add_action('admin_menu', array($this,'_addAdminPanel'));
		}

		// Save
		if(isset($_POST['save']) && isset($_GET['page']) && $_GET['page'] == basename(__FILE__)){
			$this->saveOptions();
		}
	}

	private function initOpt(){
		$this->allOpt = array_merge($this->defaultOpt['string'], $this->defaultOpt['bool']);
	}

	private function saveOptions(){
		if(empty($_POST)){
			return;
		}

		$options = $this->formatPost($_POST);

		if(!$options['feed_url']){
			$options['feed_url'] = get_bloginfo('rss2_url');
		}

		if(substr(strtoupper($options['feed_url']), 0, 7) != 'HTTP://'){
			$options['feed_url'] = 'http://'.$options['feed_url'];
		}

		if($options['twitter']){
			$options['twitter_link'] = 'http://twitter.com/'.$options['twitter'];
		}

		do_action('savePhilNaOpt');

		update_option( 'philnaopt', $options );
	}

	private function formatPost($data){
		$this->initOpt();
		foreach ($this->allOpt as $key){
			if(array_key_exists($key, $data)){
				if(in_array($key, $this->defaultOpt['string'])){
					$this->philnaOpt[$key] = rtrim( preg_replace("/\n\s*\r/",'', $data[$key]) );
				}elseif(in_array($key,$this->defaultOpt['bool'])){
					$this->philnaOpt[$key] = (bool)$data[$key];
				}
			}
		}

		return $this->philnaOpt;
	}

	/**
	 * Add a admin page
	 */
	public function _addAdminPanel(){
		add_theme_page(__('Current Theme Options',YHL), __('PhilNa Settings',YHL), 10, basename(__FILE__), array($this, '_adminPanel'));
	}

	public function _adminPanel(){
		if(!is_admin()){
			return;
		}

		include_once dirname(__FILE__).'/options_html.php';
	}
}

// do
if(is_admin()){
	new PhilNaAdmin();
}