<?php
/**
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

// no direct access
defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

function philnaComment(){
	nocache_headers();
	global $wpdb, $user_id;
	
	if(!defined('DOING_AJAX')){
		define('DOING_AJAX', true);
	}

	$comment_post_ID = (int) $_POST['comment_post_ID'];
	$status = $wpdb->get_row( $wpdb->prepare("SELECT post_status, comment_status FROM $wpdb->posts WHERE ID = %d", $comment_post_ID) );

	//检查评论状态
	if ( empty($status->comment_status) ) {
		fail(_('The post you are trying to comment on does not currently exist in the database.',YHL));
	} elseif ( 'closed' ==  $status->comment_status ) {
		fail(__('Sorry, comments are closed for this item.',YHL));
	} elseif ( in_array($status->post_status, array('draft', 'pending') ) ) {
		fail(__('The post you are trying to comment on has not been published.',YHL));
	}

	//获取POST数据
	$comment_author       = trim(strip_tags($_POST['author']));
	$comment_author_email = trim($_POST['email']);
	$comment_author_url   = trim($_POST['url']);
	$comment_content      = trim($_POST['comment']);
	$comment_type = '';

	// If the user is logged in
	$user = wp_get_current_user();
	if ( $user->ID ) {
		$comment_author       = $wpdb->escape($user->display_name);
		$comment_author_email = $wpdb->escape($user->user_email);
		$comment_author_url   = $wpdb->escape($user->user_url);
		//$_POST['_wp_unfiltered_html_comment']
		$_wp_unfiltered_html_comment = isset($_POST['_wp_unfiltered_html_comment']) ? $_POST['_wp_unfiltered_html_comment'] : '';
		if ( current_user_can('unfiltered_html') ) {
			if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_wp_unfiltered_html_comment ) {
				kses_remove_filters(); // start with a clean slate
				kses_init_filters(); // set up the filters
			}
		}
	}else{
		if ( get_option('comment_registration') ){
			fail(__('Sorry, you must be logged in to post a comment.',YHL));
		}		

		//如果使用管理员的名字或者邮箱地址评论则需要登录. 这样可以防止有人冒用管理员信息 ! 哈哈~ 真是聪明!
		$result_set = $wpdb->get_results("SELECT display_name, user_email FROM $wpdb->users WHERE display_name = '" . $comment_author . "' OR user_email = '" . $comment_author_email . "'");
		if ($result_set) {
			if ($result_set[0]->display_name == $comment_author){
				fail( __('Error: you are not allowed to use the nickname that you entered.if you are the administrator you hava to login to comment.',YHL) );
			}else{
				fail( __('Error: you are not allowed to use the email that you entered.if you are the administrator you hava to login to comment.',YHL) );
			}
		}
	}


	if ( get_option('require_name_email') && !$user->ID ) {
		if ( 6 > strlen($comment_author_email) || '' == $comment_author ){
			fail(__('Error: please fill the required fields (name, email).',YHL));
		}elseif ( !is_email($comment_author_email)){
			fail(__('Error: please enter a valid email address.',YHL));
		}
	}

	if ( '' == $comment_content ){
		fail(__('Error: please type a comment.',YHL));
	}


	// Simple duplicate check
	$dupe = "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = '$comment_post_ID' AND ( comment_author = '$comment_author' ";
	if ( $comment_author_email )
	$dupe .= "OR comment_author_email = '$comment_author_email' ";

	$dupe .= ") AND comment_content = '$comment_content' LIMIT 1";

	if ( $wpdb->get_var($dupe) ) {
		fail(__('Duplicate comment detected; it looks as though you\'ve already said that!',YHL));
	}

	//评论过快
	$ip =  preg_replace( '/[^0-9a-fA-F:., ]/', '',$_SERVER['REMOTE_ADDR'] );
	check_comment_flood_db($ip, $comment_author_email, current_time('mysql', 1));

	$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_id');

	$comment_id = wp_new_comment( $commentdata );
	$comment = get_comment($comment_id);

	if ( !$user->ID ) {
		@setcookie('comment_author_' . COOKIEHASH, $comment->comment_author, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
		@setcookie('comment_author_email_' . COOKIEHASH, $comment->comment_author_email, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
		@setcookie('comment_author_url_' . COOKIEHASH, clean_url($comment->comment_author_url), time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
	}

	$comment->ajax = true;
	@header('Content-type: ' . get_option('html_type') . '; charset=' . get_option('blog_charset'));

	//response
	philnaComments($comment, null,null);
	echo '</li>';
}