<?php
/**
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

function philnaComments($comment, $args, $depth){
	$GLOBALS['comment'] = $comment;
	global $commentcount, $user_ID, $user_id;
	if(!defined('DOING_AJAX') && !$commentcount) {
		if (get_option('page_comments')) {
			// get current comment page ID
			$r = wp_parse_args( $args, $defaults='' );
			$page = isset($r['page']) ? $r['page'] : 1;
			$commentcount = get_option('comments_per_page') * ($page - 1);
		}else{
			$commentcount = 0;
		}
	}

	if(defined('DOING_AJAX')){
		$commentcount = get_comments_number($comment->comment_post_ID)-1;
	}

	++$commentcount;

	$whois = '';

	if($comment->comment_author_email == get_the_author_email()){
		$whois = 'admincomment';
	} else {
		$whois = 'regularcomment';
	}
?>
<li id="comment-<?php comment_ID() ?>" class="comment <?php echo $whois; ?>">
	<div class="the-avatar">
		<?php echo get_avatar($comment, 50); ?>
	</div>
	<div class="action">
		<a id="reply-<?php comment_ID() ?>" class="reply" href="#comment-<?php comment_ID() ?>" title="<?php _e('Reply this comment',YHL); ?>"><?php _e('Reply', YHL); ?></a> |
		<a id="quote-<?php comment_ID() ?>" class="quote" href="#comment-<?php comment_ID() ?>" title="<?php _e('Quote this comment',YHL); ?>"><?php _e('Quote', YHL); ?></a>
		<?php if($user_ID): ?>
		<?php echo ' | <a class="comment-edit icon" href="',get_bloginfo('url'),'/wp-admin/comment.php?action=editcomment&c='.$comment->comment_ID,'" title="',__('Advanced edit',YHL),'">',__('Edit',YHL),'</a>'; ?>
		<?php endif; //endif for $user_ID ?>
	</div>
	<div class="comment-info">
	<?php if (get_comment_author_url()) : ?>
		<a href="<?php comment_author_url(); ?>" rel="external nofollow" id="commenter-<?php comment_ID(); ?>" class="commentauthor"><?php comment_author(); ?></a> |
	<?php else: ?>
		<span id="commenter-<?php comment_ID(); ?>" class="commentauthor"><?php comment_author(); ?></span> |
	<?php endif; ?>
		<a href="#commenter-<?php comment_ID(); ?>" title="Floor: <?php echo $commentcount; ?>" id="floor-<?php echo $commentcount; ?>" class="floor-id">#<?php echo $commentcount; ?></a>
		<div class="time"><?php printf( __('%1$s at %2$s', YHL), get_comment_time(__('F jS, Y', YHL)), get_comment_time(__('H:i', YHL)) ); ?></div>
	</div>
	<div class="clear"></div>
	<div id="comment-content-<?php comment_ID(); ?>" class="comment-content">
		<?php comment_text(); ?>
		<div class="clear"></div>
	</div>
<?php
} // end philnaComments

function philnaTrackbacks($trackbacks){
	global $comment;
	$trackbackcount = 0;
	foreach ($trackbacks as $comment){
	$trackbackcount++;
	$editlink = '<a class="comment-edit icon" href="' .get_bloginfo('url').'/wp-admin/comment.php?action=editcomment&c='.get_comment_ID().'" title="' . __( 'Edit comment', YHL) . '">' . __('Edit this',YHL) . '</a>';
?>
<li class="trackback">
	<div class="action">
		<?php echo $editlink; ?>
	</div>
	<div class="from">
		<a href="<?php comment_author_url() ?>" id="commenter-<?php comment_ID(); ?>" class="commentauthor"><?php comment_author(); ?></a> |
		#<?php echo $trackbackcount; ?>
	</div>
	<div class="time"><?php printf( __('%1$s at %2$s', YHL), get_comment_time(__('F jS, Y', YHL)), get_comment_time(__('H:i', YHL)) ); ?></div>
	<div class="trackback-content">
		<?php comment_text(); ?>
		<div class="clear"></div>
	</div>
</li>
<?php
	}
}
