<?php
/**
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

/**
 * 最近评论
 *
 * 这个函数主要改写自mg12的插件
 * 没有做ajax
 *
 * @param array $args 有些评论显示的设置
 * @return string|null
 */
function philnaRecentcomments($args='number=5'){

	$rcms = get_comments($args);

	//print_r($rcms);return;
	if(empty($rcms)){
		_e('No Data Found',YHL);
		return;
	}
	//<img height="40" width="40" alt="" src="http://localhost/avatar.jpg" class="avatar avatar-40 photo"/>
	//get_avatar($rcm->comment_author_email, $r['avatar_size'])
	//历遍数据
	$output = '';
	foreach( $rcms as $rcm ){
		// 如果访客昵称为空, 则将显示名字设为 "Anonymous"
		if ($rcm->comment_author == '') {
			$rcm->comment_author = __('Anonymous', YHL);
		}
		$author = $rcm->comment_author;
		$l_excerpt = philnaSubstr( $rcm->comment_content, 200 );
		$l_excerpt = strip_tags($l_excerpt);
		$s_excerpt = convert_smilies( philnaSubstr( $l_excerpt, 20 ) );
		$comment_author_link = '<a href="'.$rcm->comment_author_url.'" rel="external nofollow" title="'.$l_excerpt.'">'.$author.'</a>';

		if($rcm->comment_type == ''){
			$output .= '<li class="r_item"><div class="row">'.get_avatar($rcm->comment_author_email, 20).'<span class="r_name"><a href="'.get_comment_link($rcm).'" title="'.$l_excerpt.'">' . $rcm->comment_author . '</a></span><span class="r_excerpt">'.$s_excerpt.'</span></div><div class="clear"></div></li>'."\n";
		}elseif($rcm->comment_type == 'pingback'){
			$output .= '<li class="r_item r_pingback"><span class="rc_label name">' . __('Pingback:') . '</span>'.$comment_author_link.'</li>';
		}elseif($rcm->comment_type == 'trackback'){
			$output .= '<li class="r_item r_traback"><span class="rc_label name">' . __('Trackback:') . '</span>'.$comment_author_link.'</li>';
		}
	}
	echo $output;
}

/**
 * 边侧栏 文章链接
 *
 * 作用: 在边侧栏显示随机文章, 最近发布的文章.
 * 为了减少数据库请求.不再使用mg12的方法.
 * 目前显示很多条的情况下也不会增加额外的数据库请求
 *
 * @since 2.0
 * @version 2.1
 */
function philnaWidgetPostsLink($limit = 5){
	global $wpdb,$id,$philnaFileCache;
	if (is_single()) {
		$posts_widget_title = __('Recent Posts',YHL);
		$posts = get_posts("numberposts={$limit}&orderby=post_date");
	} else {
		$posts_widget_title = __('Random Posts',YHL);
		$posts = get_posts("numberposts={$limit}&orderby=rand");
	}

	$output = "<h3>$posts_widget_title</h3>\n";
	$output .="<ul>\n";
	if(empty($posts)){
		$output .= '<li>Can\'t found (没有找到)</li>';
		$output .= "</ul>\n";
		echo $output;
		return;
	}
	
	foreach($posts as $post) {
		$output .=  '	<li><a href="' . get_permalink($post) . '" title="' . $post->post_title . '" rel="bookmark inlinks">' . $post->post_title . '</a></li>'."\n";
	}
	
	$output .= "</ul>\n";
	echo $output;
}

/**
 * 显示相关文章 并显示摘要
 *
 * $limit 条数限制
 * $excerpt_length 摘要显示长度限制
 * $echo 是否直接打印 (否则返回数据, 以备其他函数调用)
 *
 * @since 2.0
 * @param bool $echo whether to print
 * @param string|object $ajid just for ajax
 * @param int|string $limit Limit query and output
 * @param int|string $excerpt_length Limit the excerpt outputs.Useless for feed
 */
function philnaRelatedPosts( $echo = true, $ajid='', $limit=5, $excerpt_length=85 ){
	global $wpdb, $post;
	if(!$post->ID && $ajid=''){return;}

	$tags = wp_get_post_tags($post->ID);

	if($ajid)
	$tags = wp_get_post_tags($ajid);

	$related_posts = '';

	if(!empty($tags)){
		$taglist = array();
		$tagcount = count($tags);
		if ($tagcount > 0) {
			for ($i = 0; $i < $tagcount; $i++) {
				$taglist[] = $tags[$i]->term_id;
			}
		}
		$related_query_args=array(
					'tag__in' => $taglist,
					'post__not_in' => array($post->ID),
					'showposts'=>$limit,
					'orderby'=>'rand',
					'caller_get_posts'=>1
		);
		$title =  __('Related Posts',YHL);
		$r_posts = new WP_Query($related_query_args);
		$related_posts = $r_posts->posts;
	}

	if(empty($related_posts) || empty($tags) ){
		$related_query_args=array(
					'post__not_in' => array($post->ID),
					'showposts'=>$limit,
					'orderby'=>'rand',
					'caller_get_posts'=>1
		);
		$title = __('Random Posts',YHL);
		$r_posts = new WP_Query($related_query_args);
		$related_posts = $r_posts->posts;
	}

	$related_posts['title'] = $title;

	$count = count($related_posts) -1;
	$output = '<h3>'.$related_posts['title'].'</h3>'."\n";
	$output .= '<ul class="related_posts">'."\n";
	if(empty($related_posts[0]))
	$output .= 'Not found, Sorry';

	for($i = 0; $i<$count; $i++){
		$ID = $related_posts[$i]->ID;
		$post_title = $related_posts[$i]->post_title;
		$post_content = $related_posts[$i]->post_content;
		$post_excerpt = $related_posts[$i]->post_excerpt;
		$post_password = $related_posts[$i]->post_password;
		$comment_count = $related_posts[$i]->comment_count;

		if($post_password)
		break;

		if(!empty($post_excerpt)){
			$post_content = $post_excerpt;
		}
		$post_content = strip_tags($post_content);
		$post_content = philnaSubstr($post_content,(int)$excerpt_length);

		$post_content = '<small class="excerpt">'.$post_content.'</small>';


		if(!$echo){
			$post_content='';
			$comment_count = '';
		}

		if($comment_count>0)
		$comment_count = '<span class="count">( '.$comment_count.' )</span>';
		else
		$comment_count = '';

		$output .= '<li><a href="'.get_permalink($ID).'" title="'.$post_title.'" rel="bookmark inlinks">'.$post_title.'</a>'.$comment_count.$post_content.'</li>'."\n";
	}

	$output .= '</ul>'."\n";

	if($echo)
	echo $output;
	else
	return $output;
}

/**
 * 在rss中插入相关文章
 *
 * 由于feed 的样式难以控制样式 故暂不输出摘要
 *
 * 注意:
 * 请不要重复安装相关的插件
 * 该函数不会判断是否安装了相关插件
 * 没有后台控制
 *
 * @since 2.0
 * @see add_filter
 * @see related_posts()
 */
function philnaRelatedPostsForFeed( $c ){
	if( !is_feed()){
		return $c;
	}
	$data = philnaRelatedPosts(false);

	$c .= $data;

	return $c;
}
add_filter('the_content', 'philnaRelatedPostsForFeed');

/**
 * 通过USER_Agent判断是否为机器人.
 *
 * @return Boolean
 */
function is_bot(){
	$bots = array('Google Bot1' => 'googlebot', 'Google Bot2' => 'google', 'MSN' => 'msnbot', 'Alex' => 'ia_archiver', 'Lycos' => 'lycos', 'Ask Jeeves' => 'jeeves', 'Altavista' => 'scooter', 'AllTheWeb' => 'fast-webcrawler', 'Inktomi' => 'slurp@inktomi', 'Turnitin.com' => 'turnitinbot', 'Technorati' => 'technorati', 'Yahoo' => 'yahoo', 'Findexa' => 'findexa', 'NextLinks' => 'findlinks', 'Gais' => 'gaisbo', 'WiseNut' => 'zyborg', 'WhoisSource' => 'surveybot', 'Bloglines' => 'bloglines', 'BlogSearch' => 'blogsearch', 'PubSub' => 'pubsub', 'Syndic8' => 'syndic8', 'RadioUserland' => 'userland', 'Gigabot' => 'gigabot', 'Become.com' => 'become.com','Bot'=>'bot','Spider'=>'spider','yinheli_for_test'=>'dFirefox');
	$useragent = $_SERVER['HTTP_USER_AGENT'];
	foreach ($bots as $name => $lookfor) {
		if (stristr($useragent, $lookfor) !== false) {
			return true;
			break;
		}
	}
}

function philnaCommenTooQuickly(){
	status_header('403');
}
add_action('comment_flood_trigger', 'philnaCommenTooQuickly');