<?php

/**
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

/**
 * Simply tidy page
 */

function formatPageList($r){
	return str_replace("\n", "\n\t\t\t\t\t",$r)."\n";
}
add_filter('wp_list_pages','formatPageList');

function formatContent($r){
	if(is_feed()){
		return $r;
	}
	return preg_replace('/\n|\r/', "\n\t\t\t\t\t",$r)."\n";
}
add_filter('the_content','formatPageList');

/**
 * 处理无标题文章
 *
 * 以前没有注意到,wp可以发布没有标题的文章
 * 由于SEO等方面的关系,页面部分地方用了绝对定位
 * 没有标题肯能导致页面样式'变形',难看
 *
 * 该函数还有待改进,可添加拼音等转换函数
 *
 * @since 2.0.1
 */
function philnaCreateTitle($data){
	if(empty($data['post_title']))
	$data['post_title'] = philna_substr($data['post_content'],20);
	//if(empty($data['post_name']))
	//	$data['post_name'] = $data['post_title'];//不知道有什么好东东可以转换为拼音的...
	return $data;
}
add_filter('wp_insert_post_data','philnaCreateTitle',10,1);

/**
 * 多彩标签云
 *
 * @param string $tag_link
 * @see colorCloudCallback($matches)
 * @return string
 */
function colorCloud($tag_link) {
	$tag_link = preg_replace_callback('|<a (.+?)>|i', 'colorCloudCallback', $tag_link);
	return $tag_link;
}

/**
 * 多彩标签云 回调函数
 *
 * @param $matches
 * @since 2.0.4
 * @see colorCloud($tag_link)
 * @return string
 */
function colorCloudCallback($matches) {
	$tag_link=$matches[1];
	/*颜色集合*/
	$colorFull = array('#004020', '#000060', '#40ff00', '#40ff40', '#a0ff00', '#f58220', '#ff00ff', '#333', '#222', '#999', '#200020', '#4000a0', '#400020');
	$color=$colorFull[ mt_rand(0, count($colorFull) - 1)];
	$pattern = '/style=(\'|\")(.*)(\'|\")/i';
	$tag_link= preg_replace($pattern, "style=\"color:{$color};$2;\"", $tag_link);
	return "<a $tag_link>";
}
add_filter('wp_tag_cloud', 'colorCloud', 1);


function fail($s) {
	status_header('500');
	header('Content-Type: text/plain');
	if(is_string($s))
		die($s);
	$s;
	die();
}

/* 注册边侧栏 */
if( function_exists('register_sidebar')){
	//1
	register_sidebar(array(
	'name' => __('Top widget',YHL),
	'before_widget' => '<div id="%1$s" class="widget">',
	'after_widget' => '<div class="clear"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3>'
	));

	//2
	register_sidebar(array(
	'name' => __('Center widget',YHL),
	'before_widget' => '<div id="%1$s" class="center-widget widget">',
	'after_widget' => '<div class="clear"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3>'
	));

	//3
	register_sidebar(array(
	'name' => __('Bottom widget',YHL),
	'before_widget' => '<div id="%1$s" class="widget">',
	'after_widget' => '<div class="clear"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3>'
	));
}