<?php
/**
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * Required Version:
 * PHP5 or higher
 * WordPress 2.7 or higher
 *
 * If you find my work useful and you want to encourage the development of more free resources,
 * you can do it by donating...
 * paypal: yinheli@gmail.com
 * 支付宝: foxharbour@126.com
 *
 * @author yinheli
 * @link http://philna.com
 * @copyright Copyright (C) 2008 - 2009 yinheli Open Source Matters. All rights reserved.
 * @license PhilNa is released under the GPL (see license.txt).
 * @package PhilNa
 */

defined('PHILNA') or die('Restricted access -- PhilNa gorgeous design by yinheli < http://philna.com >');

function philnaCanonical(){
	if(is_404() || is_search()){
		return;
	}
	
	if(function_exists('rel_canonical') && is_singular()){
		return;
	}
	global $post;
	if( is_home() )
		echo '	<link rel="canonical" href="'.get_bloginfo('url').'"/>',"\n";
	else
		echo  '	<link rel="canonical" href="'.get_permalink($post->ID).'"/>',"\n";
}
add_action('wp_head','philnaCanonical');

function philnaTitle( $advantage = false ){
	if( ! $advantage || $advantage !== true ){
		echo  wp_title('&laquo;', true, 'right'), bloginfo('name');
		return;
	}


	/**
	 * 自定义显示方法
	 *
	 * 首页 显示格式为 : {博客标题} - {博客描述} - {页码}
	 * 文章页, 普通页 搜索页, 分类, 存档页, Tags页.显示格式为 : {文章标题|搜索关键字|分类|存档|Tag} - {博客标题} - {页码}
	 * 页码大于1时才显示.
	 */

	 global $post, $wp_query;

	 //当前页码
	$page = $wp_query->get('paged');
	//格式化页码显示方式
	$pre = __(' - Page  ', YHL);
	if( $page && $page>1 )
		$page = $pre.$page;
	else
		$page = '';

	//首页
	if( is_home() ){
		echo bloginfo('name'), ' - ', bloginfo('description'), $page;
	//单篇文章页或者普通页面
	}elseif( is_single() || is_page() ){
		echo wp_title('',true), ' - ', bloginfo('name'), $page;
	//搜索页
	}elseif( is_search() ){
		printf(__('Search results for &quot;%1$s&quot;',YHL),
					attribute_escape(get_search_query()));
		echo ' - ', bloginfo('name'), $page;
	//分类页
	}elseif( is_category() ){
		echo single_cat_title(), ' - ', bloginfo('name'), $page;
	//Tags页 (标签页)
	}elseif( is_tag() ){
		echo single_tag_title(), ' - ', bloginfo('name'), $page;
	//存档页(目前只有月份存档,如果有需要再添加其他的存档可能)
	}elseif( is_month() ){
		printf(__('Archive for %1$s', YHL), single_month_title(' ', false));
		echo ' - ', bloginfo('name'), $page;
	//404 错误页面
	}elseif( is_404() ){
		echo __('404 Not Found  I\'m sorry', YHL), ' - ', bloginfo('name');
	//其他没有考虑到的情况
	}else{
		echo wp_title('',true), ' - ', bloginfo('name'), $page;
	}
 }


 function philnaKeywordsAndDescription( $a = false ){
	if( ! $a || $a !== true )
		return;

	global $post, $wp_query;

	//初始化
	$default_keywords = 'Wordpress,philna,theme';
	$default_desc = get_bloginfo('description');
	$keywords = '';
	$description = '';


	//首页
	if( is_home() ){
			//默认的关键字为主题后台设置的关键字.
		if($GLOBALS['philnaopt']['keywords'])
			$keywords = $GLOBALS['philnaopt']['keywords'];
		else
			$keywords = $default_keywords;

		//默认的描述字为主题后台设置的描述
		if($GLOBALS['philnaopt']['description'])
			$description = $GLOBALS['philnaopt']['description'];
		else
			$description = $default_desc;
	}elseif( is_single() || is_page() ){
		//对 keywords 的处理
		//获得自定义域 自定义的关键字 自定义域 名称为 'Keywords' 或者 'keywords' 均可.
		$keywords = array();
		$keywords[] = get_post_meta($post->ID, 'Keywords', true);
		$keywords[] = get_post_meta($post->ID, 'keywords', true);


		//仅对 单篇文章页( single ) 处理
		if( is_single() ){
			//获得分类名称 作为关键字
			$cats = get_the_category();
			if($cats){
				foreach( $cats as $cat ){
					$keywords[] = $cat->name;
				}
			}

			//获取Tags 将Tags 作为关键字
			$wp_query->in_the_loop = true;
			$tags = get_the_tags();
			if($tags){
				foreach( $tags as $tag ){
					$keywords[] = $tag->name;
				}
			}
			$wp_query->in_the_loop = false;
		}

		//格式化处理 $keywords
		if(!empty($keywords)){
			//去除值为空的项目
			foreach( $keywords as $key=>$v ){
				if($v == '')
					unset($keywords[$key]);
			}
			$keywords = join(', ', $keywords);
		}else{
			$keywords = $default_keywords;
		}

		//对 description 的处理
		//受保护的文章不需要获取 描述
		if( empty($post->post_password) ){
			//获取自定义域内容
			 $description = get_post_meta($post->ID, 'Description', true);
			 if( empty($description) )
				 $description = get_post_meta($post->ID, 'description', true);
			//自定义域为空 试试Excerpt
			if( empty($description) )
				$description = preg_replace('/\n|\r/','',get_the_excerpt());
			//依然为空 则截取文章的前N个字符作为描述
			 if( empty($description) )
				$description = philnaSubstr(strip_tags($post->post_content),320);
			//文章受到密码保护时, 描述仅为提示信息
		}else{
			$description = __('Protected post.Enter your password to view',YHL);
		}
	//分类页
	}elseif( is_category() ){
		$keywords = '';
		$description = stripslashes(strip_tags(category_description()));
	//作者页
	}elseif( is_author() ){
		$keywords = '';
		$meta_auth = get_userdata(get_query_var('author'));
		$description = str_replace(array('"'), '&quot;', $meta_auth->description);
	//标签页
	}elseif( is_tag() ){
		$keywords = single_cat_title('', false);
		$description = $keywords;
	//月份存档页
	}elseif( is_month() ){
		$description = single_month_title(' ', false);
	}else{
		$description = '';
	}

	$description = preg_replace('/\n|\r/', '', $description);

	$meta_keywords = <<<END
<meta name="keywords" content="$keywords" />\n
END;
$meta_description = <<<END
<meta name="description" content="$description" />\n
END;

	//输出
	if( !empty($keywords) )
		echo $meta_keywords;

	if( !empty($description) )
		echo $meta_description;

	//hook
 	do_action('after_keywords_desc');
}

function philnaBlogTitleAndDesc(){
	$title = get_bloginfo('name');
	$desc = get_bloginfo('description');
	$url = get_bloginfo('url');

	$home = <<<END
<h1 id="title"><a href="$url" title="$title - $desc">$title</a></h1>
					<h2 id="desc">$desc</h2>\n
END;

	$other = <<<END
<h2 id="title"><a href="$url" title="$title - $desc">$title</a></h2>
					<p id="desc">$desc</p>\n
END;

	if( is_home() ){
		echo $home;
	}else{
		echo $other;
	}
}

add_filter('wp_title', create_function('$a, $b','return str_replace(" $b ","",$a);'), 10, 2);

function philnaRePostClass($classes){
	global $post;
	$classes = (array)$classes;
	/*for the box style*/
	$classes[] = 'box';
	$classes[] = 'boxtl';
	/*单篇文章,使用绝对定位用的class*/
	if(is_single()){
		$classes[] = 'single';
	}

	/*受保护的文章*/
	if ( !empty($post->post_password) ){
		$classes[] = 'protected-post';
	}
	/*对于24小时内发布的文章添加 new-post class*/
	$postDate = $post->post_date;
	$currentTime = time()+get_option('gmt_offset')*3600;
	$timeDiff = $currentTime - strtotime($postDate);
	if($timeDiff<24*60*60*1){
		$classes[] = 'new-post';
	}
	return $classes;
}
add_filter('post_class','philnaRePostClass');

/**
 * 添加转义字符
 *
 * @param $data
 * @return string|array
 */
function philnaAddslashes($data){
	if(is_array($data)){
		foreach($data as &$value){
			philnaAddslashes($value);
		}
	}else{
		addslashes($data);
	}
	return $data;
}

/**
 * 去掉转义字符
 *
 * @param string|array $data
 * @return string|array
 */
function philnaStripslashes($data){
	if(is_array($data)){
		foreach($data as &$value){
			philnaStripslashes($value);
		}
	}else{
		stripslashes($data);
	}
	return $data;
}

/**
 * 将数组转换为字符
 *
 * 用于缓存
 *
 * @param $data
 * @return string
 */
function philnaArray2String($data, $returns = ''){
	static $t = 1;
	$tabType = "    ";
	$tab = str_repeat($tabType,$t);
	$data = (array)$data;
	foreach($data as $key=>$value){
		if(is_array($value)){
			$t++;
			$returns .= "$tab'".$key."' => array(\n".philnaArray2String($value)."$tab),\n";
		}else{
			if(!is_bool($value)){
				$value = "'".addslashes($value)."'";
			}
			$returns .= "$tab'".$key."' => $value,\n";
		}

	}
	$returns = substr_replace($returns,'',-2,-1);
	return $returns;
}

/**
 * 去掉标签
 *
 * @param string $str
 * @param string $allow
 * @return string
 */
function philnaStriptags($str,$allow = ''){
	$str = preg_replace('/(\r\n)|(\n)/', '', $str); // 消灭换行符
	$str = strip_tags($str,$allow); //去掉html标签
	$str = preg_replace('/\[(.+?)\]/', '', $str); // 消灭'[]'这样的标签
	return $str;
}

/**
 * 格式化内容
 *
 * 对内容使用滤过器
 *
 * @param string $content
 * @return string
 */
function philnaContentFormat($content){
	$content = apply_filters('the_content', $content);
	$content = str_replace(']]>', ']]&gt;', $content);
	return $content;
}

/**
 * 截取字符
 *
 * @param string $str
 * @param int $length
 * @return string
 */
function philnaSubstr($str, $len = 100){
	if(!$str){
		return;
	}

	if( strlen( $str ) <= $len ){
		return $str;
	}else{
		$ellipsis = '...';
	}

	$new_str = array();
	for($i=0;$i<$len;$i++){
		$temp_str=substr($str,0,1);
		if(ord($temp_str) > 127){
			$i++;
			if($i<$len){
				$new_str[]=substr($str,0,3);
				$str=substr($str,3);
			}
		}else{
			$new_str[]=substr($str,0,1);
			$str=substr($str,1);
		}
	}
	$new_str = join($new_str);
	$new_str .=$ellipsis;

	return $new_str;
}